echo off
getans Are you updating Ample Notice from a previous version?
if not errorlevel 1 goto version
echo See the file AN12TO13.DOC for update instructions.  Would you like 
getans to print this file (just a couple of pages) now?  
if not errorlevel 1 goto display
echo Turn on printer and
pause
printman an12to13.doc
goto fin
:display
echo Update instructions will be displayed on the screen.  To view 
echo these instructions later, enter PAGE AN12TO13.DOC.  To obtain a 
echo printed version, enter PRINTMAN AN12TO13.DOC.
pause
PAGE AN12TO13.DOC
goto fin
:version
getans ~V
if errorlevel 1 goto 5
echo Sorry!  Automatic installation does not work on DOS 3.0.  Please type
echo PAGE INSTALL.DOC to see how to install Ample Notice yourself.
goto fin
:5
set h=y
if "%1"=="" goto noarg
set s=%1
goto 110
:noarg
rem No argument given; get it...
getans ~A On which disk will Ample Notice be installed? (A,B,...)  
if errorlevel 2 goto 20
set d=A:
goto 100
:20
if errorlevel 3 goto 30
set d=B:
goto 100
:30
if errorlevel 4 goto 40
set d=C:
goto 100
:40
if errorlevel 5 goto 50
set d=D:
goto 100
if errorlevel 6 goto 5
:50
set d=E:
:100
set s=%d%
rem is it a hard drive?
getans Is %d% a hard drive? (Y,N)
if errorlevel 1 goto 105
set h=n
goto 110
:105
set s=%d%\AN
:110
echo Ample Notice will be installed in %s%.
getans OK? (Y,N)
if errorlevel 1 goto copy
echo Type ANSETUP again, followed by the drive and subdirectory you wish to 
echo use.  Example:  ANSETUP B: or ANSETUP C:\CAL
goto fin
:copy
rem copy files
if %h%==n goto 115
echo Ignore 'Unable to create directory' message...
md %s%
:115
echo %%c %s%\notes >>%s%\config.cal
echo %%a %s%\archive.cal >>%s%\config.cal
copy an.exe %s%
copy alarm.com %s%
if exist %s%\notes goto 6
copy notes %s%
goto 125
:6
echo The file %s%\NOTES already exists and will not be overwritten.  You may
echo need to change your NOTES file; see READ.ME for details.
pause
:125
rem copy other pertinent files
copy aninst.exe %s%
echo .
echo We recommend that you put %s% in your DOS path and that ALARM be
echo added to your AUTOEXEC.BAT file.  Would you like us to do this for you?
getans (Y,N) 
if not errorlevel 1 goto 10
aninst -A %s%
:10 
echo Ample Notice installation complete.
:fin  
